# -*- coding: iso-8859-1 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para seriesyonkis
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools


from pelisalacarta import buscador

CHANNELNAME = "seriesyonkis"
DEBUG = True
BASE_URL = "http://www.seriesyonkis.com"

def isGeneric():
    return True

def mainlist(item):
    logger.info("[seriesyonkis.py] mainlist")

    itemlist = []
    itemlist.append( Item(channel=CHANNELNAME, action="lastepisodes"   , title="timos captulos"))
    itemlist.append( Item(channel=CHANNELNAME, action="listalfabetico"    , title="Listado alfabetico"))
    #itemlist.append( Item(channel=CHANNELNAME, action="alltvserieslist"   , title="Listado completo de series"))
    #itemlist.append( Item(channel=CHANNELNAME, action="allcartoonslist"    , title="Listado completo de dibujos animados"))
    #itemlist.append( Item(channel=CHANNELNAME, action="allanimelist"   , title="Listado completo de anime"))
    #itemlist.append( Item(channel=CHANNELNAME, action="allminilist"    , title="Listado completo de miniseries"))
    itemlist.append( Item(channel=CHANNELNAME, action="mostviewed"    , title="Series ms vistas", url = BASE_URL + "/series-mas-vistas"))
    #itemlist.append( Item(channel=CHANNELNAME, action="minivideos"    , title="Listado completo de minivideos", url = BASE_URL + "/minivideos"))
    itemlist.append( Item(channel=CHANNELNAME, action="search"    , title="Buscar"))

    return itemlist

def mostviewed(item):
    logger.info("[seriesyonkis.py] mostviewed")
    data = scrapertools.cachePage(item.url)

    #<li class="thumb-episode"> <a href="/serie/como-conoci-a-vuestra-madre" title="Cmo conoc a vuestra madre"><img class="img-shadow" src="/img/series/170x243/como-conoci-a-vuestra-madre.jpg" height="166" width="115"></a> <strong><a href="/serie/como-conoci-a-vuestra-madre" title="Cmo conoc a vuestra madre">Cmo conoc a vuestra madre</a></strong> </li> 
    matches = re.compile('<li class="thumb-episode"> <a href="([^"]+)" title="([^"]+)".*?src="([^"]+)".*?</li>', re.S).findall(data)
    #scrapertools.printMatches(matches)
    itemlist = []
    for match in matches:               
        scrapedtitle = match[1] 
        # URL
        scrapedurl = match[0]            
        # Thumbnail
        scrapedthumbnail = BASE_URL + match[2]            
        # procesa el resto
        scrapedplot = ""

        # Depuracion
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")            
        itemlist.append( Item(channel=CHANNELNAME, action="list" , title=scrapedtitle , url=scrapedurl, thumbnail=scrapedthumbnail, plot=scrapedplot, show=scrapedtitle))

    return itemlist

def minivideos(item):
    logger.info("[seriesyonkis.py] minivideos")
    data = scrapertools.cachePage(item.url)

    #<article class="minivideo "> <a href="/minivideo/ver/cine/430365"> <img src="http://blackbird.zoomin.tv/Images/.jpg?imageurl=http://bongo.zoomin.tv/uploaded/assetimages/2011/08/26/430365.jpg&amp;width=169&amp;height=125" alt="Estreno: Dinero fcil" height="125" width="169"> </a> <p class="titulo">Estreno: Dinero fcil</p> </article>
    matches = re.compile('<article class="minivideo "> <a href="([^"]+)".*?src="([^"]+)".*?alt="([^"]+)".*?</article>', re.S).findall(data)
    #scrapertools.printMatches(matches)
    itemlist = []
    for match in matches:               
        scrapedtitle = match[2] 
        # URL
        scrapedurl = match[0]            
        # Thumbnail
        scrapedthumbnail = match[1]            
        # procesa el resto
        scrapedplot = ""

        # Depuracion
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")            
        itemlist.append( Item(channel=CHANNELNAME, action="list" , title=scrapedtitle , url=scrapedurl, thumbnail=scrapedthumbnail, plot=scrapedplot, show=scrapedtitle))

    return itemlist

def lastepisodes(item):
    logger.info("[seriesyonkis.py] lastepisodes")

    data = scrapertools.cachePage(BASE_URL + "/ultimos-capitulos")

    #<li class="thumb-episode "> <a href="/capitulo/strike-back/project-dawn-part-3/200215"><img class="img-shadow" src="/img/series/170x243/strike-back.jpg" height="166" width="115"></a> <div class="transparent"> <a href="/capitulo/strike-back/project-dawn-part-3/200215"><span>2x03</span></a> </div> <strong><a href="/serie/strike-back" title="Strike back">Strike back</a></strong> </li>
    matches = re.compile('<li class="thumb-episode ">.*?</li>', re.S).findall(data)
    #scrapertools.printMatches(matches)

    itemlist = []
    for match in matches:
        
        #<li class="thumb-episode "> <a href="/capitulo/strike-back/project-dawn-part-3/200215"><img class="img-shadow" src="/img/series/170x243/strike-back.jpg" height="166" width="115"></a> <div class="transparent"> <a href="/capitulo/strike-back/project-dawn-part-3/200215"><span>2x03</span></a> </div> <strong><a href="/serie/strike-back" title="Strike back">Strike back</a></strong> </li>
        datos = re.compile('<a href="([^"]+)">.*?src="([^"]+)".*?<span>([^<]+)</span>.*?title="([^"]+)"', re.S).findall(match)
    
        for capitulo in datos:        
            scrapedtitle = capitulo[3] + " " + capitulo[2] 
            # URL
            scrapedurl = BASE_URL + capitulo[0]            
            # Thumbnail
            scrapedthumbnail = BASE_URL + capitulo[1]            
            # procesa el resto
            scrapedplot = ""
    
            # Depuracion
            if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")            
            itemlist.append( Item(channel=CHANNELNAME, action="chapterlinks" , title=scrapedtitle , url=scrapedurl, thumbnail=scrapedthumbnail, plot=scrapedplot, show=scrapedtitle))

    return itemlist  
    

def search(item):
    logger.info("[seriesyonkis.py] search")

    return buscador.listar_busquedas(item)
    
def formsearch(text):
    
    #<input id="search-button" name="keywords" autocomplete="off" placeholder="Buscar en Series Yonkis" maxlength="60" type="text"> </form>
    url = BASE_URL + "/buscar/serie" # write ur URL here
    values = {'keywords' : text } #write ur specific key/value pair              
    
    try:
        data = urllib.urlencode(values)          
        req = urllib2.Request(url, data)
        response = urllib2.urlopen(req)
        the_page = response.read() 
        response.close()
        return the_page 
    except : 
        return "" 

def searchresults(item):
    logger.info("[seriesyonkis.py] searchresults")
    texto = item.url.replace(" ", "+")
    # Descarga la página
    data = formsearch(texto)
    
    itemlist = []
    #Paginador
    #<div class="paginator"> &nbsp;<a href="/lista-de-series/C/">&lt;</a>&nbsp;<a href="/lista-de-series/C/">1</a>&nbsp;<strong>2</strong>&nbsp;<a href="/lista-de-series/C/200">3</a>&nbsp;<a href="/lista-de-series/C/200">&gt;</a>&nbsp; </div>
    matches = re.compile('<div class="paginator">.*?<a href="([^"]+)">&gt;</a>.*?</div>', re.S).findall(data)
    if(len(matches)==1):
        for match in matches:
            itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="Pgina siguiente" , url=BASE_URL+match, thumbnail=item.thumbnail, plot="", extra = "" , show=item.show))

    
    # Extrae las entradas (carpetas)
    #<li class="blanco"> <a title="First Wave: El Elegido" href="/serie/first-wave-el-elegido"><img class="thumb" src="/img/series/100x144/first-wave-el-elegido.jpg" height="71" width="50"></a> <h3><a title="First Wave: El Elegido" href="/serie/first-wave-el-elegido">First Wave: El Elegido</a></h3> <p> Armaged.</p> </li> 
    patronvideos = '<li class=[^<]+<a title="([^"]+)" href="([^"]+)".*?src="([^"]+)".*?</li>'
    matches = re.compile(patronvideos,re.S).findall(data)
    #scrapertools.printMatches(matches)

    
    for match in matches:
        title = match[0]
        url = match[1]
        thumbnail = BASE_URL + match[2]
        itemlist.append( Item(channel=CHANNELNAME, action="list" , title=title , url=url, thumbnail=thumbnail, plot="", extra = "" , show=item.show))
        
    return itemlist

def chapterlinks(item):
    logger.info("[seriesyonkis.py] chapterlinks")
       
    Nro = 0
    fmt=id=""
    
    data = scrapertools.cachePage(item.url)    
    
    #Solo queremos los links de ONLINE
    #matches = re.compile('<h2 class="header-subtitle veronline">.*?<h2 class="header-subtitle descargadirecta">', re.S).findall(data)
    #ONLINE + DESCARGA
    matches = re.compile('<h2 class="header-subtitle veronline">.*?<section class="buy_show">', re.S).findall(data)
    #scrapertools.printMatches(matches)
    for match in matches: 
        data = match
    matches = re.compile('<tr>.*?</tr>', re.S).findall(data)
    #scrapertools.printMatches(matches)

    itemlist = []
    for match in matches:        
        #<tr> <td class="episode-server"> <a href="/s/go/674378" title="Reproducir No estamos solos 2x1" target="_blank"><img src="/img/veronline.png" height="22" width="22"> Reproducir</a> </td> <td class="episode-server-img"><a href="/s/go/674378" title="Reproducir No estamos solos 2x1" target="_blank"><span class="server megavideo"></span></a></td> <td class="episode-lang"><span class="flags esp" title="Español">esp</span></td> <td class="center"><span class="flags no_sub" title="Sin subtítulo o desconocido">no</span></td> <td> <span class="episode-quality-icon" title="Calidad del episodio"> <i class="sprite quality5"></i> </span> </td> <td class="episode-uploader">aritzatila</td> <td class="center"><a href="#" class="errorlink" data-id="674378"><img src="/img/icons/bug.png" alt=""></a></td> </tr> 
        datos = re.compile('<a href="/s/go/([^"]+)".*?<span class="server ([^"]+)".*?title="[^"]+">([^<]+)</span>.*?"flags ([^_]+)_sub".*?class="sprite quality([^"]+)"', re.S).findall(match)
        for info in datos:  
            try:
                id = info[0]
                servidor = info[1]
                Nro = Nro + 1
                fmt = info[4]      
                audio = "Audio:" + info[2]
                subs = "Subs:" + info[3]
                #<td class="title">Duración / Tamaño </td><td>85.8 min /
                data = scrapertools.cachePage(BASE_URL + "/s/go/"+ id) 
                matches = re.compile('<td class="title">Duraci.*?</td><td>([^/]+)/ .*?</td></tr>', re.S).findall(data)
                duracion = ""
                try:
                    for match in matches: 
                        duracion = match.strip()  
                        break
                except:
                    duration = ""
                data = scrapertools.cachePage(BASE_URL + "/s/y/"+ id)
                videos = servertools.findvideos(data) 
                if(len(videos)>0): 
                    for video in videos:
                        url = video[1]
                        server=video[2]                   
                        break
                    scraptedtitle = "%02d) [%s %s] - (Q:%s) (%s) [%s] " % (Nro , audio,subs,fmt,duracion,servidor)
                    itemlist.append( Item(channel=CHANNELNAME, action="play" , title=scraptedtitle , url=url, thumbnail=item.thumbnail, plot=item.plot, server=server, folder=False))
                               
            except:
                logger.info("[seriesyonkis.py] error (%s)" % servidor)

    return itemlist
  
def listalfabetico(item):
    logger.info("[seriesyonkis.py] listalfabetico")
       
    itemlist = []
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="0-9", url=BASE_URL + "/lista-de-series/0-9"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="A"  , url=BASE_URL + "/lista-de-series/A"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="B"  , url=BASE_URL + "/lista-de-series/B"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="C"  , url=BASE_URL + "/lista-de-series/C"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="D"  , url=BASE_URL + "/lista-de-series/D"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="E"  , url=BASE_URL + "/lista-de-series/E"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="F"  , url=BASE_URL + "/lista-de-series/F"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="G"  , url=BASE_URL + "/lista-de-series/G"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="H"  , url=BASE_URL + "/lista-de-series/H"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="I"  , url=BASE_URL + "/lista-de-series/I"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="J"  , url=BASE_URL + "/lista-de-series/J"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="K"  , url=BASE_URL + "/lista-de-series/K"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="L"  , url=BASE_URL + "/lista-de-series/L"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="M"  , url=BASE_URL + "/lista-de-series/M"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="N"  , url=BASE_URL + "/lista-de-series/N"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="O"  , url=BASE_URL + "/lista-de-series/O"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="P"  , url=BASE_URL + "/lista-de-series/P"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="Q"  , url=BASE_URL + "/lista-de-series/Q"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="R"  , url=BASE_URL + "/lista-de-series/R"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="S"  , url=BASE_URL + "/lista-de-series/S"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="T"  , url=BASE_URL + "/lista-de-series/T"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="U"  , url=BASE_URL + "/lista-de-series/U"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="V"  , url=BASE_URL + "/lista-de-series/V"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="W"  , url=BASE_URL + "/lista-de-series/W"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="X"  , url=BASE_URL + "/lista-de-series/X"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="Y"  , url=BASE_URL + "/lista-de-series/Y"))
    itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="Z"  , url=BASE_URL + "/lista-de-series/Z"))

    return itemlist

def listseriesthumbnails(item):
    logger.info("[seriesyonkis.py] listseriesthumbnails")    

    itemlist = []

    # Descarga la página
    data = scrapertools.cachePage(item.url)
    #logger.info(data)
    
   
    #Paginador
    #<div class="paginator"> &nbsp;<a href="/lista-de-series/C/">&lt;</a>&nbsp;<a href="/lista-de-series/C/">1</a>&nbsp;<strong>2</strong>&nbsp;<a href="/lista-de-series/C/200">3</a>&nbsp;<a href="/lista-de-series/C/200">&gt;</a>&nbsp; </div>
    matches = re.compile('<div class="paginator">.*?<a href="([^"]+)">&gt;</a>.*?</div>', re.S).findall(data)
    if(len(matches)==1):
        for match in matches:
            itemlist.append( Item(channel=CHANNELNAME, action="listseriesthumbnails" , title="Pgina siguiente" , url=BASE_URL+match, thumbnail=item.thumbnail, plot="", extra = "" , show=item.show))

    #<div id="main-section" class="lista-series">.*?</div>
    #matches = re.compile('<div id="main-section" class="lista-series">.*?</div>', re.S).findall(data)
    matches = re.compile('<ul id="list-container".*?</ul>', re.S).findall(data)    
    #scrapertools.printMatches(matches)
    for match in matches:
        data=match
        break
    
    #<li><a href="/serie/al-descubierto" title="Al descubierto">Al descubierto</a></li>
    matches = re.compile('<li>.*?href="([^"]+)".*?title="([^"]+)".*?</li>', re.S).findall(data)
    #scrapertools.printMatches(matches)

    for match in matches:
        itemlist.append( Item(channel=CHANNELNAME, action="list" , title=match[1] , url=match[0], thumbnail="", plot="", extra = "" , show=item.show))

    return itemlist

 

def alltvserieslist(params,url,category):
    allserieslist(params,url,category,"series")

def allcartoonslist(params,url,category):
    allserieslist(params,url,category,"dibujos")

def allanimelist(params,url,category):
    allserieslist(params,url,category,"anime")

def allminilist(params,url,category):
    allserieslist(params,url,category,"miniseries")

def allserieslist(params,url,category,clave):
    logger.info("[seriesyonkis.py] allserieslist")

    title = urllib.unquote_plus( params.get("title") )

    from core.item import Item

    item = Item(channel=CHANNELNAME, title=title , url=url , extra=clave )
    itemlist = getallserieslist(item)
    
    for item in itemlist:
        xbmctools.addnewfolder(item.channel , item.action , category , item.title , item.url , item.thumbnail, item.plot , item.extra )#, totalItems = item.totalItems)

    xbmcplugin.setPluginCategory( handle=int( sys.argv[ 1 ] ), category=category )
    xbmcplugin.addSortMethod( handle=int( sys.argv[ 1 ] ), sortMethod=xbmcplugin.SORT_METHOD_NONE )
    xbmcplugin.endOfDirectory( handle=int( sys.argv[ 1 ] ), succeeded=True )
    
def getallserieslist(item):
    logger.info("[seriesyonkis.py] getallserieslist")

    from core.item import Item

    itemlist = []

    # Descarga la página
    data = scrapertools.cachePage(item.url)
    #logger.info(data)

    # Extrae el bloque de las series
    patronvideos = '<h4><a.*?id="'+item.extra+'".*?<ul>(.*?)</ul>'
    matches = re.compile(patronvideos,re.DOTALL).findall(data)
    data = matches[0]
    #scrapertools.printMatches(matches)

    # Extrae las entradas (carpetas)
    patronvideos  = '<li class="page_item_"><a href="(http://www.seriesyonkis.com/serie[^"]+)"[^>]+>([^<]+)</a></li>'
    matches = re.compile(patronvideos,re.DOTALL).findall(data)
    #scrapertools.printMatches(matches)
    totalItems = len(matches)

    for match in matches:
        scrapedtitle = match[1]
        scrapedurl = match[0]
        scrapedthumbnail = ""
        scrapedplot = ""
        Serie = scrapedtitle    # JUR-Añade nombre serie para librería
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")

        # Añade al listado de XBMC
        itemlist.append( Item(channel=CHANNELNAME, action="list" , title=scrapedtitle , url=scrapedurl, thumbnail=scrapedthumbnail, plot=scrapedplot, extra = Serie , show = scrapedtitle ))#, totalItems = totalItems))

    return itemlist

def list(item):
    logger.info("[seriesyonkis.py] list")

    # Descarga la página
    data = scrapertools.cachePage(BASE_URL + item.url)

    #<div class="profile-info"> <a href="/serie/el-barco"> <img src="/img/series/170x243/el-barco.jpg" alt="El Barco" class="profile-img img-shadow" height="243" width="170"> </a>  </div>
    matches = re.compile('<div class="profile-info">.*?<img src="([^"]+)".*?</div>', re.S).findall(data)
    #scrapertools.printMatches(matches)
    thumbnail =""
    for match in matches:
        thumbnail = BASE_URL + match
        break
    #<h2 class="header-subtitle">Capítulos</h2> <ul class="menu"> 
    #<h2 class="header-subtitle">Cap.*?</h2> <ul class="menu">.*?</ul>
    matches = re.compile('<h2 class="header-subtitle">Cap.*?</h2> <ul class="menu">.*?</ul>', re.S).findall(data)
    for match in matches:
        data = match
        break
    #<li.*?
    matches = re.compile('<li.*?</li>', re.S).findall(data)
    #scrapertools.printMatches(matches)
        
    itemlist = []  

    No = 0
    for match in matches:
        if(len(matches)==1):
            itemlist = addChapters(Item(url=match, thumbnail=thumbnail))
        else:
            # Añade al listado de XBMC
            No = No + 1
            title = "Temporada "+str(No)
            itemlist.append( Item(channel=CHANNELNAME, action="season" , title= title, url=match, thumbnail=thumbnail, plot="", show = title, folder=True))

    return itemlist

def addChapters(item):
    matches = re.compile('<tr.*?<a href="([^"]+)".*?<strong> (.*?) </strong>(.*?) </a>.*?</tr>', re.S).findall(item.url)
    #scrapertools.printMatches(matches)
    
    itemlist=[]
    for match in matches:
        url = BASE_URL + match[0]
        title = match[1]+match[2]
        itemlist.append( Item(channel=CHANNELNAME, action="chapterlinks" , title= title, url=url, thumbnail=item.thumbnail, plot="", show = title, folder=True))

    return itemlist
    
def season(item):
    logger.info("[seriesyonkis.py] getlist")
    return addChapters(item)
    

def detail(params,url,category):
    logger.info("[seriesyonkis.py] detail")
    logger.info("[seriesyonkis.py] detail url="+url)

    title = urllib.unquote_plus( params.get("title") )
    thumbnail = urllib.unquote_plus( params.get("thumbnail") )
    plot = unicode( xbmc.getInfoLabel( "ListItem.Plot" ), "utf-8" )
    Serie = urllib.unquote_plus( params.get("Serie") )
    # ------------------------------------------------------------------------------------
    # Busca los enlaces a los videos
    # ------------------------------------------------------------------------------------
    #server = "Megavideo"
    server,url = scrapvideoURL(url) 
    logger.info("[seriesyonkis.py] detail url="+url)
   
    if (":" in url):
        match = url.split(":")
        if match[0]!="http":
            url = choiceOnePart(match)
    logger.info("[seriesyonkis.py] detail url="+url)

    if url == "":return
   
    logger.info("[seriesyonkis.py] url="+url)
   
    xbmctools.playvideo(CHANNELNAME,server,url,category,title,thumbnail,plot,Serie=Serie)
    # ------------------------------------------------------------------------------------

def addlist2Library(params,url,category):
    logger.info("[seriesyonkis.py] addlist2Library")

    # Descarga la página
    data = scrapertools.cachePage(url)
    #logger.info(data)

    if params.has_key("Serie"):
        Serie = params.get("Serie")
    else:
        Serie = ""

    if params.has_key("server"):
        server = params.get("server")
    else:
        server = ""

    if params.has_key("thumbnail"):
        thumbnail = params.get("thumbnail")
    else:
        thumbnail = ""

    # Extrae las entradas (carpetas)
    patronvideos  = '<a href="(http://www.seriesyonkis.com/capitulo[^"]+)"[^>]+>([^<]+)</a>'
    matches = re.compile(patronvideos,re.DOTALL).findall(data)
    scrapertools.printMatches(matches)

    pDialog = xbmcgui.DialogProgress()
    ret = pDialog.create('pelisalacarta', 'Añadiendo episodios...')
    pDialog.update(0, 'Añadiendo episodio...')
    totalepisodes = len(matches)
    logger.info ("[seriesyonkis.py - addlist2Library] Total Episodios:"+str(totalepisodes))
    i = 0
    errores = 0
    nuevos = 0
    for match in matches:
        # Titulo
        scrapedtitle = match[1]

        # PARTE NUEVA 

        # Nos quedamos por un lado con el nombre de la serie y 
        # por otro con el num capitulo

        mo = re.match("^(.*) ([\d]{1,2}[x|X][\d]{1,3}) (.*)$", scrapedtitle)

        if mo == None:
                errores = errores + 1
                continue        

        if (DEBUG):
                xbmc.output("CAPITULO="+ mo.group(2))                
    
    
        scrapedtitle = mo.group(2)

        # FIN PARTE NUEVA

        i = i + 1
        pDialog.update(i*100/totalepisodes, 'Añadiendo episodio...',scrapedtitle)
        if (pDialog.iscanceled()):
            return

        # URL
        #  Tenemos 2 opciones. Scrapear todos los episodios en el momento de añadirlos 
        #  a la biblioteca o bien dejarlo para cuando se vea cada episodio. Esto segundo
        #  añade los episodios mucho más rápido, pero implica añadir una función
        #  strm_detail en cada módulo de canal. Por el bien del rendimiento elijo la
        #  segunda opción de momento (hacer la primera es simplemente descomentar un par de
        #  líneas.
        #  QUIZÁ SEA BUENO PARAMETRIZARLO (PONER OPCIÓN EN LA CONFIGURACIÓN DEL PLUGIN)
        #  PARA DEJAR QUE EL USUARIO DECIDA DONDE Y CUANDO QUIERE ESPERAR.
        url = match [0]
        # JUR-Las 3 líneas siguientes son para OPCIÓN 1
        #scrapedurl = scrapvideoURL(url)
        #if scrapedurl == "":
        #    errores = errores + 1
            
        # Thumbnail
        scrapedthumbnail = ""
        
        # procesa el resto
        scrapedplot = ""
        # Depuracion
        if (DEBUG):
            logger.info("scrapedtitle="+scrapedtitle)
#            logger.info("scrapedurl="+scrapedurl) #OPCION 1.
            logger.info("url="+url) #OPCION 2.
            logger.info("scrapedthumbnail="+scrapedthumbnail)
            logger.info("Serie="+Serie)
            logger.info("Episodio "+str(i)+" de "+str(totalepisodes)+"("+str(i*100/totalepisodes)+"%)")

        # Añade a la librería #Comentada la opción 2. Para cambiar invertir los comentarios
        #OPCION 1:
        #library.savelibrary(scrapedtitle,scrapedurl,scrapedthumbnail,server,scrapedplot,canal=CHANNELNAME,category="Series",Serie=Serie,verbose=False)
        #OPCION 2
        try:
            nuevos = nuevos + library.savelibrary(scrapedtitle,url,scrapedthumbnail,server,scrapedplot,canal=CHANNELNAME,category="Series",Serie=Serie,verbose=False,accion="strm_detail",pedirnombre=False)
        except IOError:
            logger.info("Error al grabar el archivo "+scrapedtitle)
            errores = errores + 1
        
#    xbmcplugin.endOfDirectory( handle=int( sys.argv[ 1 ] ), succeeded=True )
    pDialog.close()
    
    #Actualización de la biblioteca
    if errores > 0:
        logger.info ("[seriesyonkis.py - addlist2Library] No se pudo añadir "+str(errores)+" episodios") 
    library.update(totalepisodes,errores,nuevos)

    return nuevos
    

def strm_detail (params,url,category):
    logger.info("[seriesyonkis.py] strm_detail")

    title = urllib.unquote_plus( params.get("title") )
    thumbnail = urllib.unquote_plus( params.get("thumbnail") )
    plot = unicode( xbmc.getInfoLabel( "ListItem.Plot" ), "utf-8" )
    #server = "Megavideo"
    # ------------------------------------------------------------------------------------
    # Busca los enlaces a los videos
    # ------------------------------------------------------------------------------------
    server,url = scrapvideoURL(url)
    if url == "":
        
        return
    logger.info("[seriesyonkis] strm_detail url="+url)
    
    xbmctools.playvideo("STRM_Channel",server,url,category,title,thumbnail,plot,1)
#<td><div align="center"><span style="font-size: 10px"><em><img src="http://simages.peliculasyonkis.com/images/tmegavideo.png" alt="Megavideo" style="vertical-align: middle;" /><img src='http://images.peliculasyonkis.com/images/tdescargar2.png' title='Tiene descarga directa' alt='Tiene descarga directa' style='vertical-align: middle;' /><a onmouseover="window.status=''; return true;" onmouseout="window.status=''; return true;" title="Seleccionar esta visualizacion" href="http://www.seriesyonkis.com/player/visor_pymeno4.php?d=1&embed=no&id=%CB%D8%DC%DD%C0%D3%E2%FC&al=%A6%B2%AC%B8%AC%A4%BD%A4" target="peli">SELECCIONAR ESTA</a> (flash desde megavideo)</em>          </span></div></td>          <td><div align="center"><img height="30" src="http://simages.seriesyonkis.com/images/f/spanish.png" alt="Audio Español" title="Audio Español" style="vertical-align: middle;" /></div></td>
#          <td><div align="center"><span style="font-size: 10px">Español (Spanish)</span></div></td>          <td><div align="center"><span style="font-size: 10px">no</span></div></td>          <td><div align="center"><span style="font-size: 10px">Formato AVI 270mb</span></div></td>          <td><div align="center"><span style="font-size: 10px">MasGlo<br />masglo</span></div></td>        </tr><tr>
 

def scrapvideoURL(urlSY):
    logger.info("[seriesyonkis.py] scrapvideoURL")
    data = scrapertools.cachePage(urlSY)
    patronvideos  = 'href="' + BASE_URL + '/s/go/(mv)\/([^"]+)".*?alt="([^"]+)".*?'
    patronvideos += '<td><div[^>]+><[^>]+>[^<]+</span></div></td>[^<]+<td><div[^>]+><[^>]+>[^<]+</span></div></td>[^<]+'
    patronvideos += '<td><div[^>]+><[^>]+>(.*?)</tr>'
    matches = re.compile(patronvideos,re.DOTALL).findall(data)
    
    patronvideos  = 'href="' + BASE_URL + '/player/visor_([^\.]+).php.*?id=([^"]+)".*?alt="([^"]+)".*?'
    patronvideos += '<td><div[^>]+><[^>]+>[^<]+</span></div></td>[^<]+<td><div[^>]+><[^>]+>[^<]+</span></div></td>[^<]+'
    patronvideos += '<td><div[^>]+><[^>]+>(.*?)</tr>'
    matches0 = re.compile(patronvideos,re.DOTALL).findall(data)
    matches = matches + matches0
    patronvideos1  = BASE_URL + '/s/go/(d)/(.+?)".*?alt="([^"]+)".*?'
    patronvideos1 += 'Durac.+?:\s?([^>]+?)>'
    matches1 = re.compile(patronvideos1,re.DOTALL).findall(data)
    if (len(matches1) > 0):
        for j in matches1:
            matches.append(j)
    scrapertools.printMatches(matches)
    id=""
    #newdec = Yonkis.DecryptYonkis()
    #xbmc.output(newdec.ccM(newdec.charting(newdec.unescape("%B7%AC%A6%B1%B7%AD%A9%B1"))))
    
    if len(matches)==0:
        xbmctools.alertnodisponible()
        return "",""
        
    elif len(matches)==1:
        if  matches[0][0] == "d":
            player = "descargar"
            url = BASE_URL + "/s/go/%s/%s" % (matches[0][0],matches[0][1])
            id = getId(url)
        elif matches[0][0] == "mv":
            player = "pymeno2"
            url = BASE_URL + "/go/%s/%s" % (matches[0][0],matches[0][1])
            id = getId(url)
        else:
            player = matches[0][0]
            id = matches[0][1]
        server = SERVER[player]
        #print matches[0][1]
        if player == "svueno":
            id = matches[0][1]
            logger.info("[seriesyonkis.py]  id="+id)
            dec = Yonkis.DecryptYonkis()
            id = dec.decryptALT(dec.charting(dec.unescape(id)))
            id = "http://stagevu.com/video/" + id
        elif player in ["pymeno2","pymeno3","pymeno4","pymeno5","pymeno6"]:
            cortar = matches[0][1].split("&")
            id = cortar[0]
            logger.info("[seriesyonkis.py]  id="+id)
            dec = Yonkis.DecryptYonkis()
            id = dec.decryptID_series(dec.unescape(id))
        
        elif player == "descargar":
            cortar = matches[0][1].split("&")
            id = cortar[0]
            logger.info("[seriesyonkis.py]  id="+id)
            dec = Yonkis.DecryptYonkis()
            id = dec.ccM(dec.unescape(id))

        else:pass
        #print 'codigo :%s' %id
        return server,id        
    else:
        
        
            
        server,id = choiceOne(matches)
        if len(id)==0:return "",""
        print 'codigo :%s' %id
        return server,id
        
        
def choiceOne(matches):
    logger.info("[seriesyonkis.py] choiceOne")
    opciones = []
    IDlist = []
    servlist = []
    Nro = 0
    fmt=duracion=id=""
    
    for server,codigo,audio,data in matches:
        try:
            print server
            if server in SERVER:
                servidor = SERVER[server]
                player = server
                id = codigo
            else:
                if server == "d":
                    player = "descargar"
                    id = BASE_URL + "/go/%s/%s" % (server,codigo)
                    
                    servidor = "Megaupload"
                    Server = "megaupload"
                elif server == "mv":
                    player = "pymeno2"
                    id = BASE_URL + "/go/%s/%s" % (server,codigo)
                    
                    servidor = "Megavideo"
                    Server = "megavideo"
                else:
                    servidor = "desconocido ("+server+")"
            Nro = Nro + 1
            
            regexp = re.compile(r"title='([^']+)'")
            match = regexp.search(data)
            if match is not None:
                fmt = match.group(1)
                fmt = fmt.replace("Calidad","").strip()
            regexp = re.compile(r"Duraci\xc3\xb3n:([^<]+)<")
            match = regexp.search(data)
            if match is not None:
                duracion = match.group(1).replace(".",":")        
            audio = audio.replace("Subt\xc3\xadtulos en Espa\xc3\xb1ol","Subtitulado") 
            audio = audio.replace("Audio","").strip()
            opciones.append("%02d) [%s] - (%s) - %s  [%s] " % (Nro , audio,fmt,duracion,servidor))
            IDlist.append(id)
            servlist.append(player)
        except:
            logger.info("[seriesyonkis.py] error (%s)" % server)
    dia = xbmcgui.Dialog()
    seleccion = dia.select("Nº)[AUDIO]-(CALIDAD)-DURACION", opciones)
    logger.info("seleccion=%d" % seleccion)
    if seleccion == -1 : return "",""
    
    if servlist[seleccion]  in ["pymeno2","pymeno3","pymeno4","pymeno5","pymeno6"]:
        if "http" in IDlist[seleccion]:
            id = getId(IDlist[seleccion])
        else:
            id = IDlist[seleccion]
        cortar = id.split("&")
        id = cortar[0]
        logger.info("[seriesyonkis.py]  id="+id)
        dec = Yonkis.DecryptYonkis()
        if(len(id)==51):                     
            id = dec.decryptID(dec.charting(dec.unescape(id)))
        else:
            id = dec.decryptID_series(dec.unescape(id))
    elif servlist[seleccion] == "descargar":
        if "http" in IDlist[seleccion]:
            id = getId(IDlist[seleccion])
        else:
            id = IDlist[seleccion]
        cortar = id.split("&")
        id = cortar[0]
        logger.info("[seriesyonkis.py]  id="+id)
        dec = Yonkis.DecryptYonkis()
        id = dec.ccM(dec.unescape(id))        
    elif servlist[seleccion] == "svueno":
        id = IDlist[seleccion]
        logger.info("[seriesyonkis.py]  id="+id)
        dec = Yonkis.DecryptYonkis()
        id = dec.decryptALT(dec.charting(dec.unescape(id)))
        id = "http://stagevu.com/video/" + id
    elif servlist[seleccion] == "movshare":
        id = IDlist[seleccion]
        logger.info("[seriesyonkis.py]  id="+id)
        dec = Yonkis.DecryptYonkis()
        id = dec.decryptALT(dec.charting(dec.unescape(id)))
    elif servlist[seleccion] == "videoweed":
        id = IDlist[seleccion]
        logger.info("[seriesyonkis.py]  id="+id)
        dec = Yonkis.DecryptYonkis()
        id = dec.decryptID(dec.charting(dec.unescape(id)))
        id = "http://www.videoweed.com/file/%s" %id                
    else:
        pass
    return SERVER[servlist[seleccion]],id

def choiceOnePart(matches):
    logger.info("[seriesyonkis.py] choiceOnePart")
    opciones = []
    Nro = 0
    for codigo in matches:
        Nro = Nro + 1
        opciones.append("Parte %s " % Nro)
       
    dia = xbmcgui.Dialog()
    seleccion = dia.select("Selecciona uno ", opciones)
    logger.info("seleccion=%d" % seleccion)
    if seleccion == -1 : return ""
    id = matches[seleccion]
    return id
    
def getId(url):
    logger.info("[seriesyonkis.py] getId")

    #print url
    try:
        req = urllib2.Request(url)
        req.add_header('User-Agent', 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3')
        opener = urllib2.build_opener(SmartRedirectHandler())
        response = opener.open(req)
    except ImportError, inst:    
        status,location=inst
        logger.info(str(status) + " " + location)    
        movielink = location
    #print movielink

    try:
        id = re.compile(r'id=([A-Z0-9%]{0,})').findall(movielink)[0]
    except:
        id = ""
    
    return id
    
class SmartRedirectHandler(urllib2.HTTPRedirectHandler):
    def http_error_302(self, req, fp, code, msg, headers):
        raise ImportError(302,headers.getheader("Location"))